/**
 * Javier Abelln, 23 Mayo 2006
 * 
 * Pequeo JEditorPane que hace de navegador web.
 * No entiende demasiadas florituras en las pginas web, pero permite navegar
 * por pginas html sencillas, mostrando imgenes e hiperenlaces.
 */
package chuidiang.paneles;

import javax.swing.JEditorPane;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;
import javax.swing.text.html.HTMLEditorKit;

/**
 * Pequeo visor de pginas html 
 * @author Chuidiang
 */
public class EditorHtml extends JEditorPane
{
    /**
     * serial uid
     */
    private static final long serialVersionUID = 3257844398468511543L;
    
    /**
     * Listener para el tratamiento del click en los hipervnculos, haciendo
     * que el navegador muestre la pgina apuntada por el hipervnculo.
     */
    private HyperlinkListener listener = new HyperlinkListener()
    {
        /** Nos llamarn aqu cada vez que hay cualquier evento de ratn sobre
         * un hipervnculo: movimiento del ratn por encima, clicks, etc.
         */
        public void hyperlinkUpdate(HyperlinkEvent e)
        {
            try
            {
                // Se comprueba si se ha hecho click
                if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED)
                {
                    // se obtiene la url a la que apunta el hiperlink
                    if (e.getURL() != null)
                    {
                        // Se pasa la pgina al editor
                        setPage(e.getURL().toString());
                    }
                }
            } catch (Exception e2)
            {
                // No se hace nada en caso de error.
            }
        }
    };
    
    /**
     * Construye una instancia de esta clase.
     * Es un JEditorPane preparado para html, no editable.
     */
    public EditorHtml()
    {
        HTMLEditorKit kit = new HTMLEditorKit();
        setEditorKitForContentType("text/html", kit);
        setEditable(false);
        kit.install(this);
        addHyperlinkListener(listener);
    }

}
